
/*
  IR, RC5, diag 4x 1" RGBDigit's on a RGBdigitSchield 
   
 The circuit:
 * For use on the RGBDigitSchield with a IR kit 
 * 
 * RGBDigit Digit's attached on pin 12 Arduino microcontroller (UNO) 
 * Ad a 470 ohm resistor between pin 12 of the microcontroller and Data in (Di)Pin2 from first RGBDigit 
 * This code is configured for 4 1"RGBDigit's is 32 RGBLED's

 **************************************************************************************************************************************
 
 * NOTE  Do not connect RGBDigit's to a life arduino(UNO) controller                                                                  *
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015  
 by RGBDigit < http://rgbdigit.com >
 modified 4 Mrt 2015
 by Coen   RGBDigit
 Version SIRD_V15.03.04
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
 This example code is in the public domain.

*/


// nu met Adafruit_NeoPixel library  
#include "Wire.h"                                            // for using i2c 
#include <Serial.h>                                          // for sending debug data to serial monitor
#include <Adafruit_NeoPixel.h>                               // for using RGB Adafruit neopixels
#include <IRremote.h>

#define PIN 12                                               // Sending neopixel data to Pin 12 

// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(32, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////////////////

int dag_teller = 0;
int dag_teller_vul = 0;

long randNumber;
const int analogInPin0 = A0;  // Analog input pin that the potentiometer is attached to
const int analogInPin1 = A1;  // Analog input pin that the potentiometer is attached to
const int analogInPin2 = A2;  // Analog input pin that the potentiometer is attached to
const int analogInPin3 = A3;  // Analog input pin that the potentiometer is attached to
int sensorValue1 = 0;        // value read from the pot
int sensorValue2 = 0;        // value read from the pot
int sensorValue3 = 0;        // value read from the pot
int sensorValue4 = 0;        // value read from the pot

byte digit1 = 0;
byte digit11 = 1;
byte digit2 = 0;
byte digit22 = 4; 
byte digit3 = 0;
byte digit4 = 10;
byte digit5 = 0;
byte digit6 = 0;
byte Red = 0;
byte Green = 0;
byte Blue = 0;
byte id = 0;
byte segmtloop = 0;
byte Lednum = 0;
byte Bright = 40;
byte color_scheme = 2;
byte heu = 0;
byte Temppos = 1;
byte Exit_menu = 0;

//----------IR settings---------------------------------------------
int IR_VAL = 0;
const int RECV_PIN = 10;
IRrecv irrecv(RECV_PIN);
decode_results results;
//#define POWER 0x10EFD827 
#define P 0x10EFD827 
#define A 0x10EFF807 
#define B 0x10EF7887
#define C 0x10EF58A7
#define UP 0x10EFA05F
#define DOWN 0x10EF00FF
#define LEFT 0x10EF10EF
#define RIGHT 0x10EF807F
#define SELECT 0x10EF20DF


//-------------Color array  48 RGBleds = 6 RGBSegments----------------------------------------------------------------------------------------------------------------------------------------------------
               // a    b  c   d    e  f   g     h | a   b   c   d   e   f    g   h | a   b   c   d   e   f    g   h |a  b  c  d  e  f  g  h|a  b  c  d  e  f  g  h|a  b  c  d  e  f  g  h  
byte Rarray[] = {180, 50, 0, 200, 10, 0, 150,   60,180, 50, 0, 200, 10, 90, 150, 60,180, 50, 0, 200, 10, 90, 150, 60,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Garray[] = {180, 10, 255, 200, 210, 0, 150, 60,180, 50, 0, 200, 10, 90, 150, 60,180, 50, 0, 200, 10, 90, 150,60,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Barray[] = {180, 150, 255, 200, 10, 0, 150, 60,180, 50, 0, 200, 10, 90, 150, 60,180, 50, 0, 200, 10, 90, 150,60,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0,0, 0, 0, 0, 0, 0, 0, 0};// array van 48

//------character table------------------------------------------------------------------------------

//            2-dimensional array of segment a,b,c,d,e,f,g,h data:   each character has its own colum
//                                          0 1 2 3 4 5 6 7 8 9 c - off
              byte  segmtarray [8][13] = { {1,0,1,1,0,1,0,1,1,1,1,0,0},    //a             a
                                           {1,1,1,1,1,0,0,1,1,1,0,0,0},    //b          f     b
                                           {1,1,0,1,1,1,1,1,1,1,0,0,0},    //c             g
                                           {1,0,1,1,0,1,1,0,1,1,0,0,0},    //d          e     c
                                           {1,0,1,0,0,0,1,0,1,0,0,0,0},    //e             d
                                           {1,0,0,0,1,1,1,0,1,1,1,0,0},    //f
                                           {0,0,1,1,1,1,1,0,1,1,1,1,0},    //g  
                                           {0,0,0,0,0,0,0,0,0,0,0,0,0},};  //h   

//-----I2c settings---------------------------------------------- 
              char lm92address = 0x48;      //Adress 0 A1 A0 are grounded
              char buffer[2];
              int tempcode;
              float temp;
//---------------------------------------------------------------

void setup() {

              strip.begin();
              strip.show();                     // Initialize all pixels to 'off'
              strip.setBrightness(Bright);      	// For safety (to prevent too high of a power draw), the test case defaults to 40
                      
                    //---------------------------------------------------------------
            	    // sanity check delay - allows reprogramming if accidently blowing power w/leds
               	    delay(500);
                    Wire.begin();
                    Serial.begin(9600); // open een seriele port
               	          
//                    digit1 = 0; digit2 =0; digit3 =0; digit4 =0;    //digit5 = 50;  digit6 = 50;
//                    strip.setBrightness(Bright);  //  LEDS.setBrightness(Bright);
//                    strip.show();
//                    vertaal_digits();
//                    Stream_LEDdata_fade(); 
//----------IR settings---------------------------------------------  
  irrecv.enableIRIn(); // Start the receiver   
              }

//---------Main loop---------------------------------------------------------------------------

void loop() { 
              delay(300);                                       // 2 second interval      
              read_ir();
//              Serial.print("Main loop "); Serial.println(IR_VAL ); 

                    read_temp();                                 // read temperature and fill digit1,digit2,digit3,digit4 (unit conversion)
//                    temp_to_color();                             // convert temp value to color  
//                    translate_digits_no_new_color(); 
//                    //translate_digits();                        // translate 
//                    Stream_LEDdata_fade();                       // stuur led data naar buiten

 switch (IR_VAL){
 case 10:
     Exit_menu = 1;
     Main_menu();
     
 break;
 default:
       Serial.print("Default loop "); Serial.println(IR_VAL );
  
 }
 irrecv.resume(); // Receive the next value
            }                                             
//---------end main loop----------------------------------------------------------------------
//-------Main menu loop-----------------------------------
void Main_menu()
    {
     while (Exit_menu == 1) {
       
       Serial.print("Main menu looooooooooooop "); Serial.println(IR_VAL );
       delay(1000);
       read_ir();
       
       switch (IR_VAL){
         case 11:
                 Exit_menu = 0;
         break; 
       }
       }
    }  
//-------Read IR-------Vul IR_VAL-----------------------------------
void read_ir()
  {  //IR_VAL = 0;
      if (irrecv.decode(&results)) 
      { 
        if (results.value == P) 
        { Serial.println("POWER");  IR_VAL = 10;   }
        if (results.value == A) 
        { Serial.println("A");      IR_VAL = 11;   }
         if (results.value == B) 
        { Serial.println("B");      IR_VAL = 12;   }
         if (results.value == C) 
        { Serial.println("C");      IR_VAL = 13;   }
         if (results.value == UP) 
        { Serial.println("UP");     IR_VAL = 14;   }
         if (results.value == DOWN) 
        { Serial.println("DOWN");   IR_VAL = 15;   }
         if (results.value == LEFT) 
        { Serial.println("LEFT");   IR_VAL = 16;   }
         if (results.value == RIGHT) 
        { Serial.println("RIGHT");  IR_VAL = 17;   }
         if (results.value == SELECT) 
        { Serial.println("SELECT"); IR_VAL = 18;   }
             delay(500);
     irrecv.resume();
      } 
  }
//-----I2c temp inlezen--------------------------------------------------- 
void read_temp(){
  delay(20);
 Wire.requestFrom(lm92address,2); 

  if (Wire.available()) 

  {
    for (int i=0; i<2; i++) {
      buffer[i]= Wire.read();
    }
tempcode= ((buffer[0] << 8) + buffer[1]) >>3;
temp = tempcode * 0.0625;
 if (temp <= 0)
    {temp = temp * -1;
     heu = temp;
     Temppos = 0;}     // temp is negatif
  else
    {heu = temp;
     Temppos = 1;}     // temp is positif

  if (Temppos == 1){    
       
       digit1= temp/10;
       digit11 =digit1;
       if (digit1 == 0){digit1=12;} 
           digit2=temp-(digit11*10);

           int temp2=temp;
           int digit33=(temp-temp2)*1000;
      
           digit3 = digit33/100;
           digit4 = 10;
//                          leds[15] = CRGB(Green, Red, Blue);
//                          LEDS.show();
       // digit1 = 10;
       Serial.print("tempje = "); 
       Serial.print(temp);
       Serial.print(" C");
       Serial.println();  }
     else {
       digit1 = 11;      // 
              
       digit2= temp/10;
        digit22 = digit2;  
        if (digit2 == 0){digit2=12;}
        
       digit3=temp-(digit22*10);
       int temp2=temp;
       int digit33=(temp-temp2)*1000;
       digit4 = digit33/100;
//                          leds[23] = CRGB(Green, Red, Blue);
//                          LEDS.show();

          }
// Serial.print("digit1 = "); 
// Serial.print(digit1);
// Serial.println(); 
// Serial.print("digit2 = "); 
// Serial.print(digit2);
// Serial.println(); 
// Serial.print("digit3 = "); 
// Serial.print(digit3);
// Serial.println(); 
// Serial.print("digit33 = "); 
// Serial.print(digit33);
// Serial.println();
// Serial.print("digit4 = "); 
// Serial.print(digit4);

 Serial.println(); Serial.println();
}
}  
//-----temp to color convertion---------------------------------------------- 
void temp_to_color(){
//  Serial.print(sensorValue4); Serial.println("  heu "); 
  //heu = sensorValue4;
 
   Serial.println("temp to color convertion "); 
   Serial.print("heu before "); Serial.println(heu);
   if (Temppos == 0 ) { Serial.print("temp (posneg) is nu neg "); Serial.println(Temppos);
               Blue = heu * 5;
               Green = 250 - Blue; 
               Red = 0;} 
    else {Serial.print("temp (posneg) is nu pos "); Serial.println(Temppos);
                           if (heu > 75) { Blue=0; Red=250; Green=0;}
                          else { 
                                Blue = 0;
                                Red = heu * 3;
                                Green = 250 - Red;  } }  

    
      Serial.println(" ");  
    

     Show_data();
}  
  
//---------------------------------------------------------------
void translate_digits(){                               // vertaal digit1-2-3-4 waarde naar juiste segment led's 
 
  Lednum =0;
  segmtloop =0;
  color_scheme = 2; 
        while (segmtloop < 8)                        // vertaal digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { //run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1; }
          segmtloop = segmtloop + 1; 
        }
     
  //   run_color_scheme();
       
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { //run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  color_scheme = 3;       
 //run_color_scheme();
        
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { //run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  
 // run_color_scheme();
 
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { //run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        } 
        
 run_color_scheme();
    color_scheme = 4;      
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { //run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }

//run_color_scheme();

  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { //run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }
} 
//---------------------------------------------------------------
void translate_digits_no_new_color(){                               // vertaal digit1-2-3-4 waarde naar juiste segment led's 
 
  Lednum =0;
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1; }
          segmtloop = segmtloop + 1; 
        }
     
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
      
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  
  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        } 

  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }

  segmtloop =0;

        while (segmtloop < 8)                        // vertaal digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }
} 

//-----------------------------------------------------------------------------
void Stream_LEDdata_fade(){
                        id = 0;
                        while (id < 32)
                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   //leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
                              id++; 
                          } 
   
                        if (Temppos == 1){        
                            strip.setPixelColor(15, Red, Green,  Blue);}
                        else {
                            strip.setPixelColor(23, Red, Green,  Blue);}  
                        strip.show();//LEDS.show();   
                        delay(10);}
//-----------------------------------------------------------------------------
void Show_data(){
//    Serial.println("start");
//      Serial.print(Lednum)    ;Serial.print(" lednum \t") ; 
//       Serial.print(segmtloop) ;Serial.print("segmtloop \t") ;
//       Serial.print(digit1) ;  ;Serial.print("digit1 \t") ;
//       Serial.print(segmtarray [digit1][segmtloop]); ;Serial.print("segmtarray  \t") ; 
//       Serial.print(segmtarray [y][x]); ;Serial.print("segmtarray  \t") ; 
 Serial.print("    green\t"); Serial.print(Green); // Serial.print(Rarray[1]);
 Serial.print("    red\t"); Serial.print(Red); 
 Serial.print("    blue\t"); Serial.print(Blue);
 Serial.print("    heu "); Serial.println(heu);  //Serial.println(id);
Serial.println(" ");
}  
//-----run color scheme---------------------------------------------- 
void run_color_scheme(){
  switch (color_scheme){
    case 1: 
         randNumber = random(250);
//        Serial.print("Randnummer tot 250 is "); Serial.println(randNumber);  
          Green =  random(250);
          Red =  random(250);
          Blue =  random(250);
          break;
//        // print a random number from 10 to 19
//        randNumber = random(10, 20);
//        Serial.print("Randnummer tussen 10 en 20 is " ); Serial.println(randNumber);
    case 2:   //  red 100 and  green 10 to 100
          Green = random(10,100);
          Red =  100;   //random(250);
          Blue = 0;     //random(250);    
    
    break;
    case 3:   //  red 100 and  green 10 to 100
          Green = 130;  // random(10,100);
          Red =  0;   //random(250);
          Blue = random(10,200);     //random(250);
    
    break;
    case 4:   //  red 100 and  green 10 to 100
          Green = 0; // random(10,100);
          Red =  random(10,200);   //random(250);
          Blue = 170;     //random(250);
    
    break;    
  }
}            

